this.addEventListener('install', function(event) {
  console.log('installed !');
});

this.addEventListener('activate', function(event) {
  console.log('activated !');
});

self.addEventListener('fetch', function(event) {
  console.log('fetch Event');
  const requestURL = new URL(event.request.url);

  if (requestURL.origin !== location.origin) return;

   if (requestURL.pathname.endsWith("test.txt")) {
     const queuingStrategy = new CountQueuingStrategy({ highWaterMark: 3 });

     let count = 0;
     const readableStream = new ReadableStream({
       start(controller) {
         console.log('started');
       },
       pull(controller) {
         if (count === 10) {
           controller.close();
           return;
         }

         let pullPromiseHandler = null;

         const pullPromise = new Promise((resolve, reject) => {
           pullPromiseHandler = {
             resolve: resolve,
             reject: reject
           };
         });

         setTimeout(() => {
           console.log('we enqueue, desiredSize : ', controller.desiredSize);
           const data = new TextEncoder().encode('Lorem ipsum dolor sit amet, at ius falli consul, quo ei diam novum, has ne insolens sapientem. Mea velit aliquando sadipscing in. Te mea scripta admodum maiorum, albucius scriptorem mel in. Diam appareat qui cu, solet eripuit cum at. Utinam oportere vis in, cu munere noster discere vim. \n');
           controller.enqueue(data);
           pullPromiseHandler.resolve();
           count += 1;
         }, 1000);

         return pullPromise;
       },
       cancel() {
         console.log('canceled');
       },
     }, queuingStrategy);

     event.respondWith(
       new Response(
        readableStream,
        {
          headers: {
            'Content-Type': 'text/plain; charset=utf-8',
            'Content-Disposition': 'attachment; filename="test.txt"',
          },
        },
      )
    );
   }
});
